import org.junit.Before;
import org.junit.After;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 * The test class RationalTest1. Tests the GCD function.
 *
 * @author  Uno Holmer
 * @version 2012-09-11
 */
public class RationalTest1
{
    /**
     * Default constructor for test class RationalTest
     */
    public RationalTest1()
    {
    }

    /**
     * Sets up the test fixture.
     *
     * Called before every test case method.
     */
    @Before
    public void setUp()
    {
    }

    /**
     * Tears down the test fixture.
     *
     * Called after every test case method.
     */
    @After
    public void tearDown()
    {
    }
    
    @Test
    public void testGCD() {
        assertEquals(1, Rational.gcd(1, 1));
        assertEquals(1, Rational.gcd(7, 13));
        assertEquals(1, Rational.gcd(13, 7));
        assertEquals(14, Rational.gcd(14, 14));
        assertEquals(7, Rational.gcd(7, 14));
        assertEquals(7, Rational.gcd(14, 7));
        assertEquals(7, Rational.gcd(168, 49));
        assertEquals(7, Rational.gcd(49, 168));
        assertEquals(4, Rational.gcd(12, 8));  
        assertEquals(4, Rational.gcd(12, -8)); 
        assertEquals(4, Rational.gcd(-12, 8)); 
        assertEquals(4, Rational.gcd(-12, -8));  
    }
    
    @Test    
    public void testGCDZero() {
        assertEquals(5, Rational.gcd(5, 0));
        assertEquals(5, Rational.gcd(0, 5));
        assertEquals(5, Rational.gcd(-5, 0));
        assertEquals(5, Rational.gcd(0, -5));
    }
    
    @Test(expected=ArithmeticException.class)
    public void testGCDZeroZero() {
        Rational.gcd(0, 0);
    }
}