import org.junit.Before;
import org.junit.After;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 * The test class RationalTest2. Tests the function in step 2.
 *
 * @author  Uno Holmer
 * @version 2012-09-03
 */
public class RationalTest2
{
    /**
     * Default constructor for test class RationalTest
     */
    public RationalTest2()
    {
    }

    /**
     * Sets up the test fixture.
     *
     * Called before every test case method.
     */
    @Before
    public void setUp()
    {
    }

    /**
     * Tears down the test fixture.
     *
     * Called after every test case method.
     */
    @After
    public void tearDown()
    {
    }
    
    @Test    
    public void testDefaultConstructor() {
        Rational r = new Rational();
        assertEquals(0, r.getNumerator());
        assertEquals(1, r.getDenominator());
    }
    
    @Test
    public void testIntConstructor() {
        Rational r = new Rational(5);
        assertEquals(5, r.getNumerator());
        assertEquals(1, r.getDenominator());
    }
    
    @Test
    public void testIntIntConstructor() {
        Rational r = new Rational(20, 4);
        assertEquals(5, r.getNumerator());
        assertEquals(1, r.getDenominator());
        
        r = new Rational(-20, 4);
        assertEquals(-5, r.getNumerator());
        assertEquals(1, r.getDenominator());

        r = new Rational(20, -4);
        assertEquals(-5, r.getNumerator());
        assertEquals(1, r.getDenominator());
        
        r = new Rational(-20, -4);
        assertEquals(5, r.getNumerator());
        assertEquals(1, r.getDenominator());
        
        r = new Rational(0, 5);
        assertEquals(0, r.getNumerator());
        assertEquals(1, r.getDenominator()); 
    }
    
    @Test(expected=IllegalStateException.class)
    public void testIntIntConstructorZeroNumerator() {
        new Rational(123, 0);
    }
    
    @Test
    public void testCopyConstructor() {
        Rational r = new Rational(new Rational(5, 3));
        assertEquals(5, r.getNumerator());
        assertEquals(3, r.getDenominator());
    }
    
    @Test
    public void testIsZero() {
        Rational z1 = new Rational(0);
        Rational z2 = new Rational(0, 1);
        Rational z3 = new Rational(0, 5);
        Rational z4 = new Rational(0, -5);
        assertTrue(z1.isZero());
        assertTrue(z2.isZero());        
        assertTrue(z3.isZero());       
        assertTrue(z4.isZero());
    }   
}