import org.junit.Before;
import org.junit.After;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 * The test class RationalTest3. 
 * Tests the cloning, equality and comparison methods in the third step.
 *
 * @author  Uno Holmer
 * @version 2012-09-10
 */
public class RationalTest3
{
    /**
     * Default constructor for test class RationalTest
     */
    public RationalTest3()
    {
    }

    /**
     * Sets up the test fixture.
     *
     * Called before every test case method.
     */
    @Before
    public void setUp()
    {
    }

    /**
     * Tears down the test fixture.
     *
     * Called after every test case method.
     */
    @After
    public void tearDown()
    {
    }
    
     @Test
    public void testEquals() {        
        Rational x = new Rational(6, 2);
        Rational y = new Rational(0);
        Rational z = new Rational(0, 1);
        Rational w = new Rational(75,25);
        
        assertEquals("x == x", x, x);
        assertEquals("6/2 == 75/25", x, w);
        assertEquals("75/25 == 6/2", w, x);
        assertEquals("0 == 0/1", y, z);
        assertEquals("0/1 == 0", z, y);
        
        assertFalse("6/2 == 0", x.equals(y));
        assertFalse("0 == 6/2", y.equals(x));
    }
    
    @Test
    public void testLessThan() {
        Rational x = new Rational(1, 5);
        Rational y = new Rational(2, 9);
        assertTrue("1/5 < 2/9",x.lessThan(y));
        assertFalse("2/9 < 1/5", y.lessThan(x));
        
        x = new Rational(-5, 9);
        y = new Rational(1, 2);
        assertTrue("-5/9 < 1/2", x.lessThan(y));
        assertFalse("1/2 < -5/9", y.lessThan(x));
        
        x = new Rational(1);
        assertFalse("1 < 1", x.lessThan(x));
    }
    
    @Test
    public void testClone() {
        Rational x = new Rational(6, 2);
        Rational xc = x.clone();
        
        assertEquals("x.equals(x.clone())", x, xc);
        assertNotSame("x == x.clone()", x, xc);
    }
}
    