import org.junit.Before;
import org.junit.After;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 * The test class RationalTest4. 
 * Tests the parsing and toString methods in the fourth step.
 *
 * @author  Uno Holmer
 * @version 2012-09-10
 */
public class RationalTest4
{
    /**
     * Default constructor for test class RationalTest
     */
    public RationalTest4()
    {
    }

    /**
     * Sets up the test fixture.
     *
     * Called before every test case method.
     */
    @Before
    public void setUp()
    {
    }

    /**
     * Tears down the test fixture.
     *
     * Called after every test case method.
     */
    @After
    public void tearDown()
    {
    }
    
    @Test
    public void testParseInt() {
        Rational r = Rational.parse("7");
        assertEquals(7, r.getNumerator());
        assertEquals(1, r.getDenominator());
    }
    
    @Test
    public void testParseIntInt() {
        Rational r = Rational.parse("1/3");
        assertEquals(1, r.getNumerator());
        assertEquals(3, r.getDenominator());
    }
    
    @Test
    public void testParseIntInSpaces() {
        Rational r = Rational.parse("  1  /  3  ");
        assertEquals(1, r.getNumerator());
        assertEquals(3, r.getDenominator());
    }
    
    @Test(expected=NumberFormatException.class)
    public void testParseMissingNumerator() {
        Rational.parse("/123");
    }
    
        
    @Test(expected=NumberFormatException.class)
    public void testParseMissingDenominator() {
        Rational.parse("123/");
    }
        
    @Test(expected=NumberFormatException.class)
    public void testParseJunk() {
        Rational.parse("abc");
    }
    
    @Test
    public void testParseToString() {
        String s = (new Rational(1, 3)).toString();
        Rational r = Rational.parse("1/3");
        assertEquals(s, r.toString());
        assertEquals(r, Rational.parse(s));
    }           
}
    