import org.junit.Before;
import org.junit.After;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 * The test class RationalTest5. 
 * Tests the arithmetic operations in the fifth step.
 *
 * @author  Uno Holmer
 * @version 2012-09-03
 */
public class RationalTest5
{
    /**
     * Default constructor for test class RationalTest
     */
    public RationalTest5()
    {
    }

    /**
     * Sets up the test fixture.
     *
     * Called before every test case method.
     */
    @Before
    public void setUp()
    {
    }

    /**
     * Tears down the test fixture.
     *
     * Called after every test case method.
     */
    @After
    public void tearDown()
    {
    }
               
    @Test
    public void testAdd() {
        Rational x = new Rational(1, 3);
        Rational y = new Rational(1, 4);
        Rational z = x.add(y);
        Rational w = y.add(x);
        
        assertEquals("z.equals(w)", z, w);
        assertEquals(7, z.getNumerator());
        assertEquals(12, z.getDenominator());
    }
    
    @Test
    public void testSub() {
        Rational x = new Rational(1, 3);
        Rational y = new Rational(1, 4);
        Rational z = x.sub(y);
        Rational w = y.sub(x);
        
        assertFalse("1/3-1/4 != 1/4-1/3", z.equals(w));
        assertEquals(1, z.getNumerator());
        assertEquals(12, z.getDenominator());
    }
    
    @Test
    public void testMul() {
        Rational x = new Rational(2, 9);
        Rational y = new Rational(4, 5);
        Rational z = x.mul(y);
        Rational w = y.mul(x);

        assertEquals(z, w);
        assertEquals(8, z.getNumerator());
        assertEquals(45, z.getDenominator());
    }
    
    @Test
    public void testDiv() {
        Rational x = new Rational(3, 7);
        Rational y = new Rational(5, 11);
        Rational z = x.div(y);
        Rational w = y.div(x);
        
        assertFalse("3/7 / 5/11 != 5/11 / 3/7", z.equals(w));
        assertEquals(33, z.getNumerator());
        assertEquals(35, z.getDenominator());
    }
    
    @Test(expected=ArithmeticException.class)
    public void testDivZeroNumerator() {
        Rational x = new Rational(1, 2);
        Rational y = new Rational(0, 7);
        x.div(y);
    } 
}
    